# TodoMVC API

> Validate your TodoMVC backend

[TodoMVC](//todomvc.com/) API contains the [apiblueprint](//apiblueprint.org/) [spec](todos.apib) and a [dredd](//github.com/apiaryio/dredd) wrapper to run validation tests against [TasteStack](//github.com/tastejs/TasteStack) TodoMVC backends.


## Install

```sh
$ npm install --save-dev todomvc-api
```


## Use with [gulp.js](//gulpjs.com) and [Express](//expressjs.com)

```js
var todomvc = require('todomvc-api');

gulp.task('test', function (done) {

	// Start your API server.
	var server = app.listen(8080, function () {

		// Run the TodoMVC validation test suite.
		todomvc.validate(function (err, stats) {

			// Shut down the server & pass a helpful message to Gulp.
			server.close(function () {
				if (stats && (stats.errors || stats.failures)) {
					done('api validation failed');
					return;
				}

				done(err);
			});
		});
	});
});
```


## API

### validate([url], callback)

#### url

Type: `string`
Default: `http://localhost:8080`

The base location to ping your API.

#### callback

*Required*
Type: `function`

This callback is executed with the results of our test suite against your API server.
